#!/bin/bash

set -euo pipefail

mount_sonar_data_drive() {
  if [[ -b "/dev/nvme1n1" ]]
  then
    ## Only format if not already formatted
    if [[ $(lsblk -no KNAME,FSTYPE /dev/nvme1n1 | wc -w) == 1 ]]
    then
      mkfs -t ext4 /dev/nvme1n1
    else
      echo "Not formatting /dev/nvme1n1 because it already has a filesystem"
    fi
    echo '/dev/nvme1n1 /opt/sonarqube/data ext4 defaults,discard 0 0' | sudo tee -a /etc/fstab
    mount /opt/sonarqube/data
    chown sonarqube:sonarqube /opt/sonarqube/data
  else
    echo "/dev/nvme1n1 does not exist."
  fi
}

update_sonar_conf() {
  aws configure set default.region ap-southeast-2
  #:FIXME: parameterise aws region
  POSTGRES_USER="$(aws --region ap-southeast-2 ssm get-parameter --name "/devops/sonarqube/dev/terraformgenerated/postgres_master_user" | jq -r .Parameter.Value)"
  POSTGRES_PASSWORD="$(aws --region ap-southeast-2 ssm get-parameter --name "/devops/sonarqube/dev/terraformgenerated/postgres_master_password" --with-decryption | jq -r .Parameter.Value)"
  POSTGRES_DB_NAME="$(aws --region ap-southeast-2 ssm get-parameter --name "/devops/sonarqube/dev/terraformgenerated/aurora_postgres_db_name" | jq -r .Parameter.Value)"
  POSTGRES_ENDPOINT="$(aws --region ap-southeast-2 ssm get-parameter --name "/devops/sonarqube/dev/terraformgenerated/aurora_postgres_endpoint" --with-decryption | jq -r .Parameter.Value)"

  #:FIXME: Change to echo to stop printing password to stdout
  tee /opt/sonarqube/conf/sonar.properties <<EOF
# autogenerated from AWS SSM Parameter Store
sonar.jdbc.username=${POSTGRES_USER}
sonar.jdbc.password=${POSTGRES_PASSWORD}
sonar.jdbc.url=jdbc:postgresql://${POSTGRES_ENDPOINT}/${POSTGRES_DB_NAME}
EOF
}

restart_sonar() {
  systemctl stop sonarqube.service
  systemctl start sonarqube.service
}

main() {
  mount_sonar_data_drive
  update_sonar_conf
  restart_sonar
}

main "$@"
